/// <reference types="react" />
import * as React from 'react';
import flatpickr from 'flatpickr';
import { Cancelable } from 'lodash';
export interface InputFlatpickrProps extends flatpickr.Options.Options {
    theme?: 'dark' | 'material_blue' | 'material_green' | 'material_orange' | 'material_red' | 'airbnb' | 'confetti';
    value?: string;
    placeholder?: string;
    inputName?: string;
    inputReadonly?: boolean;
    disabled?: boolean;
    handleInputBlur?(data: {
        input: HTMLInputElement;
        value: string;
    }): void | Promise<void>;
    handleInputChange?(data: {
        input: HTMLInputElement;
        value: string;
    }): void | Promise<void>;
}
export declare class InputFlatpickr extends React.Component<InputFlatpickrProps> {
    static defaultProps: {
        placeholder: string;
        inputReadonly: boolean;
        disabled: boolean;
        handleInputBlur({ target, value }: {
            target: HTMLInputElement;
            value: string;
        }): void;
    };
    input: HTMLInputElement | null;
    flatpickrElement: HTMLElement | null;
    readonly flatpickrOptions: flatpickr.Options.Options;
    componentWillMount(): void;
    componentWillReceiveProps(nextProps: InputFlatpickrProps): void;
    shouldComponentUpdate(nextProps: InputFlatpickrProps): boolean;
    componentDidMount(): void;
    handleInputChange: (() => void) & Cancelable;
    handleInputBlur: (() => void) & Cancelable;
    setInput: (input: HTMLInputElement | null) => void;
    setFlatpickerElementRef: (div: HTMLElement | null) => void;
    cancel: (ev: React.FormEvent<HTMLButtonElement>) => void;
    render(): JSX.Element;
}
