"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var flatpickrFn = require("flatpickr");
// @ts-ignore
var ja_1 = require("flatpickr/dist/l10n/ja");
var lodash_1 = require("lodash");
var go_1 = require("react-icons/lib/go");
var InputFlatpickr = /** @class */ (function (_super) {
    __extends(InputFlatpickr, _super);
    function InputFlatpickr() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.input = null;
        _this.flatpickrElement = null;
        _this.handleInputChange = lodash_1.debounce(function () {
            if (_this.props.handleInputChange === undefined) {
                return;
            }
            _this.props.handleInputChange({
                // @ts-ignore: Ignore null
                target: _this.input,
                // @ts-ignore: Ignore null
                value: _this.input.value
            });
        }, 80);
        _this.handleInputBlur = lodash_1.debounce(function () {
            if (_this.props.handleInputBlur === undefined) {
                return;
            }
            // @ts-ignore: Ignore null
            _this.props.handleInputBlur({
                // @ts-ignore: Ignore null
                target: _this.input,
                // @ts-ignore: Ignore null
                value: _this.input.value
            });
            _this.handleInputChange();
        }, 80);
        _this.setInput = function (input) {
            _this.input = input;
        };
        _this.setFlatpickerElementRef = function (div) {
            _this.flatpickrElement = div;
        };
        _this.cancel = function (ev) {
            ev.preventDefault();
            ev.stopPropagation();
        };
        return _this;
    }
    Object.defineProperty(InputFlatpickr.prototype, "flatpickrOptions", {
        get: function () {
            var options = __assign({}, this.props);
            delete options.theme;
            delete options.value;
            delete options.placeholder;
            delete options.placeholder;
            delete options.handleInputChange;
            delete options.handleInputBlur;
            delete options.inputReadonly;
            delete options.disabled;
            return __assign({ 
                // defaultOptions
                locale: ja_1.Japanese }, options);
        },
        enumerable: true,
        configurable: true
    });
    InputFlatpickr.prototype.componentWillMount = function () {
        var _this = this;
        // @ts-ignore
        Promise.resolve().then(function () { return require('flatpickr/dist/flatpickr.css'); });
        if (this.props.theme) {
            Promise.resolve().then(function () { return require("flatpickr/dist/themes/" + _this.props.theme + ".css"); });
        }
    };
    InputFlatpickr.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.value !== nextProps.value) {
            // @ts-ignore: Ignore null
            this.input.value = nextProps.value;
        }
    };
    InputFlatpickr.prototype.shouldComponentUpdate = function (nextProps) {
        return JSON.stringify(this.props) !== JSON.stringify(nextProps);
    };
    InputFlatpickr.prototype.componentDidMount = function () {
        var _this = this;
        if (this.props.value !== undefined) {
            // @ts-ignore: Ignore null
            this.input.value = this.props.value;
        }
        if (this.props.disabled) {
            return;
        }
        // @ts-ignore: Ignore null
        flatpickrFn(this.flatpickrElement, __assign({}, this.flatpickrOptions, { defaultDate: new Date(), 
            // tslint:disable-next-line variable-name
            onChange: function (_timestamp, dateStr) {
                // @ts-ignore: Ignore null
                _this.input.value = dateStr;
                _this.handleInputChange();
            } }));
    };
    InputFlatpickr.prototype.render = function () {
        return (React.createElement("div", { className: "react-input-flatpickr-Box" },
            React.createElement("input", { ref: this.setInput, className: "react-input-flatpickr-Input", placeholder: this.props.placeholder, onBlur: this.handleInputBlur, onChange: this.handleInputChange, name: this.props.inputName, readOnly: this.props.inputReadonly && !this.props.disabled, disabled: this.props.disabled }),
            React.createElement("button", { type: "button", className: "react-input-flatpickr-Button", ref: this.setFlatpickerElementRef, onClick: this.cancel },
                React.createElement("span", { "data-input": true, className: "react-input-flatpickr-Icon" },
                    React.createElement(go_1.GoCalendar, null)))));
    };
    InputFlatpickr.defaultProps = {
        placeholder: 'YYYY-MM-DD',
        inputReadonly: false,
        disabled: false,
        handleInputBlur: function (_a) {
            var target = _a.target, value = _a.value;
            if (!/^\d{4}-\d{2}-\d{2}$/.test(value || '')) {
                // @ts-ignore: Ignore null
                target.value = '';
            }
        }
    };
    return InputFlatpickr;
}(React.Component));
exports.InputFlatpickr = InputFlatpickr;
